2021-07-08       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* www/tools/texi2tr/html/download.tpl:  Changed git
	instructions to reference gcc git repro.
	* www/tools/createhtml.py:  HREF_10 substitution
	implemented.

2021-07-02       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* www/Makefile.in:  alter html build to to include web release
	$(RELEASE) and subdirectory $(RELEASE).
	* www/tools/createhtml.py:  __RELEASE__ substitution implemented.
	* www/tools/texi2tr/html/about.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/development.tpl:  use
	__WEBRELEASE__/development.html redirect.
	* www/tools/texi2tr/html/download.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/homepage.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/license.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/news.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/platforms.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/release.tpl:  changed to use 11_HREF.
	* www/tools/texi2tr/html/users.tpl:  changed to use 11_HREF.
	* m2/gm2.texi:  removed duplicate sentance.

2021-07-01       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* www/Makefile.in:  moved {news,community,development}.html
	into .tpl and adjusted the rules.
	* www/tools/createhtml.py:  (__WEBRELEASE__) substitution
	implemented.  (usage) New function.  Handle the -w option.
	* www/tools/texi2tr/html/news.tpl:  (New file).
	* www/tools/texi2tr/html/development.tpl:  (New file).
	* www/tools/texi2tr/html/community.tpl:  (New file).
	* www/Makefile.in:  remove development.html rule.
	* www/tools/texi2tr/html/users.tpl:  (using) reference use
	__WEBRELEASE__.  (obtaining) reference use __WEBRELEASE__.
	(libraries) reference use __WEBRELEASE__.
	* www/tools/texi2tr/html/title.ht:  use template for HOME_HREF
	and 12_HREF.
	* www/Makefile.in:  create copy of title.ht in build directory
	and include build directory in template path for texi2tr.
	* www/Makefile.in:  corrected install rule.
	* www/Makefile.in:  added -w option to invocation of createhtml.py.

2021-06-30       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* www/Makefile.in:  copy $(RELEASE)/*.{html,png} files into
	WWWROOT/www/gm2/$(RELEASE).
	* www/tools/createhtml.py:  add 11_HREF substitution.
	* www/tools/texi2tr/html/release.tpl:  added note about GCC_11.
	* www/tools/texi2tr/html/texi2tr.css:  updated to include new
	style for release tag.
	* www/tools/texi2tr/src/outputdev.py:  (setSubDirectory)
	New method.
	* www/tools/texi2tr/src/texi2tr.py:  set subDirectory.
	Join subdirectory to node.  Permit -s subdirectory option.

2021-05-06       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-compiler/M2GenGCC.mod:  remove GetTokenNo
	from import.  (UseBuiltin) introduce new parameter tokenno
	and use this instead of GetTokenNo ().  Change all calls to
	UseBuiltin to pass the tokenno across.  Fixes a bug (a bad error
	position) seen if a constant is created by a folded builtin
	procedure function.

2021-05-03       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/patches/gcc/11.1.0:  (New patch dir added).
	* m2/patches/gcc/01-patches:  (New file).
	* m2/patches/gcc/02-patches:  (New file).
	* m2/patches/gcc/03-patches:  (New file).
	* m2/patches/gcc/04-patches:  (New file).
	* m2/patches/gcc/05-patches:  (New file).
	* m2/patches/gcc/06-patches:  (New file).
	* m2/patches/gcc/07-patches:  (New file).
	* m2/patches/gcc/08-patches:  (New file).
	* m2/patches/gcc/09-patches:  (New file).
	* m2/patches/gcc/10-patches:  (New file).
	* m2/patches/gcc/11-patches:  (New file).
	* m2/patches/gcc/12-patches:  (New file).
	* m2/patches/gcc/13-patches:  (New file).
	* m2/patches/gcc/14-patches:  (New file).
	* m2/patches/gcc/15-patches:  (New file).
	* m2/patches/gcc/16-patches:  (New file).
	* m2/patches/gcc/17-patches:  (New file).
	* m2/patches/gcc/18-patches:  (New file).
	* m2/patches/gcc/19-patches:  (New file).
	* m2/patches/gcc/20-patches:  (New file).
	* m2/patches/gcc/21-patches:  (New file).
	* m2/patches/gcc/22-patches:  (New file).
	* m2/patches/gcc/23-patches:  (New file).

2021-04-28       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gcc_11_1_0_gm2:  (New branch).

2021-04-28       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/Make-lang.in:  added gmp.h header file include directories to
	the m2rte plugin compile rule.
	* m2/mc-boot/GDynamicStrings.c:  regenerated.
	* m2/mc-boot/GEnvironment.c:  regenerated.
	* m2/mc-boot/GFIO.c:  regenerated.
	* m2/mc-boot/GFormatStrings.c:  regenerated.
	* m2/mc-boot/GIO.c:  regenerated.
	* m2/mc-boot/GIndexing.c:  regenerated.
	* m2/mc-boot/GM2EXCEPTION.c:  regenerated.
	* m2/mc-boot/GPushBackInput.c:  regenerated.
	* m2/mc-boot/GRTExceptions.c:  regenerated.
	* m2/mc-boot/GRTint.c:  regenerated.
	* m2/mc-boot/GSArgs.c:  regenerated.
	* m2/mc-boot/GSFIO.c:  regenerated.
	* m2/mc-boot/GStdIO.c:  regenerated.
	* m2/mc-boot/GStringConvert.c:  regenerated.
	* m2/mc-boot/GSysStorage.c:  regenerated.
	* m2/mc-boot/GTimeString.c:  regenerated.
	* m2/mc-boot/Galists.c:  regenerated.
	* m2/mc-boot/Gdecl.c:  regenerated.
	* m2/mc-boot/Gkeyc.c:  regenerated.
	* m2/mc-boot/Glists.c:  regenerated.
	* m2/mc-boot/GmcComment.c:  regenerated.
	* m2/mc-boot/GmcComp.c:  regenerated.
	* m2/mc-boot/GmcDebug.c:  regenerated.
	* m2/mc-boot/GmcError.c:  regenerated.
	* m2/mc-boot/GmcLexBuf.c:  regenerated.
	* m2/mc-boot/GmcMetaError.c:  regenerated.
	* m2/mc-boot/GmcOptions.c:  regenerated.
	* m2/mc-boot/GmcPretty.c:  regenerated.
	* m2/mc-boot/GmcPrintf.c:  regenerated.
	* m2/mc-boot/GmcSearch.c:  regenerated.
	* m2/mc-boot/GmcStack.c:  regenerated.
	* m2/mc-boot/GmcStream.c:  regenerated.
	* m2/mc-boot/Gmcp1.c:  regenerated.
	* m2/mc-boot/Gmcp2.c:  regenerated.
	* m2/mc-boot/Gmcp3.c:  regenerated.
	* m2/mc-boot/Gmcp4.c:  regenerated.
	* m2/mc-boot/Gmcp5.c:  regenerated.
	* m2/mc-boot/GnameKey.c:  regenerated.
	* m2/mc-boot/GsymbolKey.c:  regenerated.
	* m2/mc-boot/Gvarargs.c:  regenerated.
	* m2/mc-boot/Gwlists.c:  regenerated.
	* m2/mc/keyc.mod:  redefine NULL for OpenBSD.
	* testsuite/gm2/analyzer/fail/callbyref3badreturn.mod:  added dg-warning.
	* testsuite/gm2/analyzer/fail/testnoreturn.mod:  added dg-warning.

2021-04-26       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-compiler/M2Quads.mod:  improve formatting.
	* m2/gm2-compiler/SymbolTable.mod:  improve formatting.
	* m2/patches/gcc/trunk/19-patches:  (New file).
	* m2/patches/gcc/trunk/20-patches:  (New file).
	* m2/patches/gcc/trunk/21-patches:  (New file).
	* m2/patches/gcc/trunk/22-patches:  (New file).
	* m2/patches/gcc/trunk/23-patches:  (New file).

2021-04-18       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/patches/gcc/trunk/16-patch: (on_deallocator_call)
	defends against skip_reference returning NULL.

2021-04-17       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/bnf/m2-1.bnf:  calls to BuildNumber pass tokenpos.
	* m2/bnf/m2-2.bnf:  calls to BuildNumber pass tokenpos.
	* m2/bnf/m2-3.bnf:  calls to BuildNumber pass tokenpos.
	* m2/bnf/m2-c.bnf:  calls to BuildNumber pass tokenpos.
	* m2/bnf/m2-h.bnf:  calls to BuildNumber pass tokenpos.
	* m2/bnf/m2.bnf:  calls to BuildNumber pass tokenpos.
	* m2/gm2-compiler/M2Base.mod:  improved formatting.
	* m2/gm2-compiler/M2GCCDeclare.def:  (TryDeclareConstructor)
	removed unused quad parameter.
	* m2/gm2-compiler/M2GCCDeclare.mod:  (TryDeclareConstructor)
	removed unused quad parameter.
	* m2/gm2-compiler/M2GenGCC.mod:  Removed unused quad parameter
	to TryDeclareConstructor.
	* m2/gm2-compiler/M2Quads.def:  (BuildEndFor) use endpostok.
	Tightened up the accuracy of the tokens used in subexpressions.
	* m2/gm2-compiler/M2Quads.mod:  (BuildEndFor) use endpostok.
	Tightened up the accuracy of the tokens used in subexpressions.

2021-04-16       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/patches/gcc/trunk/16-patch: (remade patch with
	ability to track SysStorage and Storage heaps).
	* testsuite/gm2/analyzer/fail:  (new tests added).
	* m2/gm2-compiler/M2Quads.mod:  (BuildDesignatorPointer)
	use ptrtok position and check for NIL dereference.
	Create virtual token for resulting subexpression.
	* m2/gm2-compiler/M2Quads.def:  (BuildDesignatorPointer)
	pass ptrtok position.
	* m2/bnf/m2-3.bnf:  pass token number to BuildDesignatorPointer.

2021-04-14       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/bnf/m2-3.bnf: cosmetic formatting changes.
	* m2/gm2-compiler/M2Quads.mod: (BuildAssignmentWithoutBounds)
	introduce a tok position and use it.  (MoveWithMode) use token
	position.  (doBuildAssignment) use token position and use GenQuadO
	with the token position parameter.
	(AssignHighField) pass token position to
	BuildAssignmentWithoutBounds.  Changed all calls to
	BuildAssignmentWithoutBounds passing in the becomes token
	position.  (BuildReturn) use GenQuadO with the token position of
	the RETURN keyword.  (BuildStaticArray) create virtual token
	position for subexpression.  (BuildDynamicArray) create virtual
	token for subexpression.  (ConvertBooleanToVariable)
	introduce token position and use it instead of GetTokenNo ().
	(BuildBooleanVariable) use token number on the stack associated
	with the operand.  (PushTFADrwtok) replaces PushTFADrw.
	(PushTFDtok) replaces PushTFD.  (PushTFDrwtok) replaces PushTFDrw.
	Changed all calls to replacement procedures.
	* m2/patches/gcc/trunk/16-patch: (remade patch).
	* m2/patches/gcc/trunk/17-patch: (remade patch).
	* m2/patches/gcc/trunk/18-patch: (remade patch).
	* m2/patches/gcc/trunk/19-patch: (New patch).
	* m2/gm2-lang.c: (gm2_langhook_new_dispose_storage_substitution)
	New function.  (LANG_HOOKS_NEW_DISPOSE_STORAGE_SUBSTITUTION)
	defined to gm2_langhook_new_dispose_storage_substitution.

2021-04-10       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-libs/RTint.mod: guard against NEW (v) failing.
	* m2/patches/gcc/trunk/16-patch: (remade patch).

2021-04-09       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/patches/gcc/trunk/16-patch: (remade patch).

2021-04-08       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/bnf/m2-3.bnf: (AssignmentOrProcedureCall) pass function token
	number to BuildProcedureCall.
	* m2/gm2-compiler/M2Quads.mod: (BuildProcedureCall) use functok
	and generate combinedtok.
	(BuildNewProcedure) use functok and combinedtok for
	accurate token position for generated results.
	(BuildDisposeProcedure) use functok and combinedtok for
	accurate token position for generated results.
	(BuildRealFunctionCall) pass tokno to BuildRealFunctionCall.
	(BuildPseudoProcedureCall) pass tokno to lower level procedures.
	* m2/gm2-lang.c: remove #if 1 debugging aids.
	* m2/patches/gcc/trunk/{17,18}-patch: (New files).
	* m2/patches/gcc/trunk/{16,17,18-patch}: (remade patches).

2021-04-07       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/patches/gcc/trunk/16-patches: added analyzer patch.

2021-03-05       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/Make-lang.in: invoke all shell scripts using sh.

2021-03-04       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-tools/M2Emit.mod:  (InternalError) call abort.
	* m2/Make-lang.in: invoke all shell scripts with the appropriate
	interpreter.

2021-02-16       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-compiler/M2ALU.mod: changed calls to InternalError to use
	a single parameter.
	* m2/gm2-compiler/M2Base.mod: changed calls to InternalError to
	use a single parameter.
	* m2/gm2-compiler/M2Check.mod: changed calls to InternalError to
	use a single parameter.
	* m2/gm2-compiler/M2Error.mod: changed calls to InternalError to
	use a single parameter.
	* m2/gm2-compiler/M2GCCDeclare.mod: changed calls to InternalError
	to use a single parameter.
	* m2/gm2-compiler/M2GenGCC.mod:  changed calls to InternalError to
	use a single parameter.
	* m2/gm2-compiler/M2MetaError.mod:  changed calls to InternalError
	to use a single parameter.
	* m2/gm2-compiler/M2Quads.mod:  changed calls to InternalError to
	use a single parameter.
	* m2/gm2-compiler/M2Range.mod:  changed calls to InternalError to
	use a single parameter.
	* m2/gm2-compiler/P2SymBuild.mod:  changed calls to InternalError
	to use a single parameter.
	* m2/gm2-compiler/P3SymBuild.mod:  changed calls to InternalError
	to use a single parameter.
	* m2/gm2-compiler/PCSymBuild.mod:  changed calls to InternalError
	to use a single parameter.
	* m2/gm2-compiler/Sets.mod:  changed calls to InternalError to use
	a single parameter.
	* m2/gm2-compiler/SymbolConversion.mod:  changed calls to
	InternalError to use a single parameter.
	* m2/gm2-compiler/SymbolTable.mod:  changed calls to InternalError
	to use a single parameter.
	* m2/gm2-tools/M2Emit.mod:  changed calls to InternalError to use
	a single parameter.

2021-02-15       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-compiler/Lists.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2ALU.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2AsmUtil.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2Base.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Batch.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2CaseList.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2Check.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Const.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Debug.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2DebugStack.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2Emit.def:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Emit.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Error.def:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Error.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2GCCDeclare.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2GenGCC.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2MetaError.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2Optimize.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2Pass.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Quads.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2Range.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2StackAddress.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2StackWord.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/M2Swig.mod:  all calls to InternalError changed
	to use single parameter.
	* m2/gm2-compiler/M2System.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/P2SymBuild.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/PCSymBuild.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-compiler/Sets.mod:  all calls to InternalError changed to
	use single parameter.
	* m2/gm2-compiler/SymbolConversion.mod:  all calls to
	InternalErrorchanged to use single parameter.
	* m2/gm2-compiler/SymbolTable.mod:  all calls to InternalError
	changed to use single parameter.
	* m2/gm2-tools/M2Emit.mod:  all calls to InternalError changed to
	use single parameter.

2021-02-10       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/mc-boot/Gmcp5.c:  (SubDesignator) check to see if expression
	is NIL.
	* m2/bnf/mc-5.bnf:  (SubDesignator) check to see if expression
	is NIL.
	* m2/gm2-gcc/rtegraph.c:  (DEBUGGING) includes complete functions
	rather than just the body of a function.
	* m2/gm2-compiler/M2Check.mod:  (isTrue) commented out.
	(checkTypeEquivalence) completed comment.  (checkTypeEquivalence)
	removed unused parameter tInfo and added comments.
	(checkSubrange) completed comment and check for result known
	at beginning.  (checkGenericTypeEquivalence) completed comment.
	(checkSystemEquivalence) completed comment and removed unused
	tInfo parameter.  (checkEnumerationEquivalence) removed unused
	tInfo parameter.  (checkPointerType) completed comment and removed
	unused tInfo parameter.  (checkValueEquivalence) completed comment and
	removed unused tInfo parameter.  (visit) removed.
	(checkSkipEquivalence) removed unused parameter tInfo.
	(checkRecordEquivalence) removed unused parameter tInfo.
	(getCompatible) removed.

2021-01-29       Gaius Mulley <gaius.mulley@southwales.ac.uk>

        * m2/gm2-compiler/M2GenGCC.mod:  (ToSubrange) removed unused export.
        * m2/gm2-gcc/m2convert.c:  (ToSubrange) removed.
        * m2/gm2-gcc/m2convert.h:  (ToSubrange) removed.
        * m2/gm2-libs/SArgs.mod:  Reverted change.

2021-01-27       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-compiler/M2BasicBlock.def:  (KillBasicBlock) use
	optional return.
	* m2/gm2-compiler/M2BasicBlock.mod:  (KillBasicBlock) parameter
	is VAR and the parameter is assigned to NIL.  (FreeBasicBlocks)
	New procedure.  (BasicBlock) declared without unnecessary
	forward type.  (InitBasicBlocks) formatting.
	* m2/gm2-compiler/M2Code.mod:  (Percent) formatting.
	(SecondDeclareAndOptimize) remove unnecessary variable bb.
	Use FreeBasicBlocks on functional basic block evaluations.
	* m2/gm2-compiler/M2GenGCC.mod:  (IsExported) Reformatted.
	* m2/gm2-compiler/M2LexBuf.mod:  (GetToken) call GetToken
	without using the return result to advance token position.
	* m2/gm2-compiler/m2flex.def:  (GetToken) declared with optional
	return result.
	* m2/gm2-gcc/gcc-consolidation.h:  corrected dates.
	* m2/gm2-gcc/init.c:  corrected dates.
	* m2/gm2-gcc/init.def:  corrected dates.
	* m2/gm2-gcc/init.h:  corrected dates.
	* m2/gm2-gcc/m2assert.c:  corrected dates.
	* m2/gm2-gcc/m2assert.h:  corrected dates.
	* m2/gm2-gcc/m2block.c:  corrected dates.
	* m2/gm2-gcc/m2block.def:  corrected dates.
	* m2/gm2-gcc/m2block.h:  corrected dates.
	* m2/gm2-gcc/m2builtins.c:  corrected dates.
	* m2/gm2-gcc/m2builtins.def:  corrected dates.
	* m2/gm2-gcc/m2builtins.h:  corrected dates.
	* m2/gm2-gcc/m2color.c:  corrected dates.
	* m2/gm2-gcc/m2color.def:  corrected dates.
	* m2/gm2-gcc/m2color.h:  corrected dates.
	* m2/gm2-gcc/m2convert.c:  corrected dates.
	* m2/gm2-gcc/m2convert.def:  corrected dates.
	* m2/gm2-gcc/m2convert.h:  corrected dates.
	* m2/gm2-gcc/m2decl.c:  corrected dates.
	* m2/gm2-gcc/m2decl.def:  corrected dates.
	* m2/gm2-gcc/m2decl.h:  corrected dates.
	* m2/gm2-gcc/m2except.c:  corrected dates.
	* m2/gm2-gcc/m2except.def:  corrected dates.
	* m2/gm2-gcc/m2except.h:  corrected dates.
	* m2/gm2-gcc/m2expr.c:  corrected dates.
	* m2/gm2-gcc/m2expr.def:  corrected dates.
	* m2/gm2-gcc/m2expr.h:  corrected dates.
	* m2/gm2-gcc/m2linemap.c:  corrected dates.
	* m2/gm2-gcc/m2linemap.def:  corrected dates.
	* m2/gm2-gcc/m2linemap.h:  corrected dates.
	* m2/gm2-gcc/m2misc.c:  corrected dates.
	* m2/gm2-gcc/m2misc.def:  corrected dates.
	* m2/gm2-gcc/m2misc.h:  corrected dates.
	* m2/gm2-gcc/m2options.h:  corrected dates.
	* m2/gm2-gcc/m2range.h:  corrected dates.
	* m2/gm2-gcc/m2search.h:  corrected dates.
	* m2/gm2-gcc/m2statement.c:  corrected dates.
	* m2/gm2-gcc/m2statement.def:  corrected dates.
	* m2/gm2-gcc/m2statement.h:  corrected dates.
	* m2/gm2-gcc/m2top.c:  corrected dates.
	* m2/gm2-gcc/m2top.def:  corrected dates.
	* m2/gm2-gcc/m2top.h:  corrected dates.
	* m2/gm2-gcc/m2tree.c:  corrected dates.
	* m2/gm2-gcc/m2tree.def:  corrected dates.
	* m2/gm2-gcc/m2tree.h:  corrected dates.
	* m2/gm2-gcc/m2treelib.c:  corrected dates.
	* m2/gm2-gcc/m2treelib.def:  corrected dates.
	* m2/gm2-gcc/m2treelib.h:  corrected dates.
	* m2/gm2-gcc/m2type.c:  corrected dates.
	* m2/gm2-gcc/m2type.def:  corrected dates.
	* m2/gm2-gcc/m2type.h:  corrected dates.
	* m2/gm2-gcc/rtegraph.c:  corrected dates.
	* m2/gm2-gcc/rtegraph.h:  corrected dates.
	* m2/patches/gcc/trunk:  rebuilt all patches.
	* m2/gm2-compiler/M2Base.mod:  (InitBuiltins) check builtins to
	ensure source file was found.  (GetBaseTypeMinMax) remove unused
	local variable.  (GetBaseTypeMinMax) reformatted.
	(InitBaseProcedures):  check rtexceptions to determine whether
	source file was found.
	* m2/gm2-compiler/M2Code.mod:  (CodeBlock) KillScopeBlock no
	longer returns a value.
	* m2/gm2-compiler/M2GCCDeclare.mod:
	(DeclareTypesConstantsProcedures) KillScopeBlock no longer returns
	a value.
	* m2/gm2-compiler/M2Scope.def:  (KillScopeBlock) remove
	return result and pass sb by reference.
	* m2/gm2-compiler/M2Scope.mod:  assign parameter to NIL.
	* m2/gm2-compiler/M2Swig.mod: (DetermineParameter) KillBasicBlock
	no longer returns a value.
	* m2/gm2-gcc/m2type.c:  (build_set_type) commented out.
	(convert_type_to_range) commented out.
	* m2/gm2-libs/SArgs.mod:  convert pointer to non void * pointer before
	performing arithmetic.
	* gcc/m2/gm2-compiler/M2Optimize.mod:  (DisplayReachable)
	exported.
	* gcc/m2/gm2-compiler/M2Optimize.def:  (DisplayReachable)
	exported.

2021-01-25       Gaius Mulley <gaius.mulley@southwales.ac.uk>

        * gcc/m2/Make-lang.in:  supply subdirectory parameter to makeversion.
        Invoke makeversion without changing into a subdirectory.
        * gcc/m2/tools-src/makeversion:  added subdirectory argument.
        All output files are placed into the supplied subdirectory.
	* gcc/m2/patches/gcc/trunk/15-patches:  (New file) git front end
	patch.

2021-01-16       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* patches/gcc/trunk/02-patches:  (corrected path depth).
	* gcc/m2/Make-lang.in:  added dependancies $(PLUGIN_HEADERS) alongside
	$(TARGET_H).
	* gcc/m2/config-lang.in:  corrected dates.
	* gcc/m2/configure.ac:  corrected dates.
	* gcc/m2/gm2-internals.texi:  corrected dates.
	* gcc/m2/gm2-lang.c:  corrected dates.
	* gcc/m2/gm2-lang.h:  corrected dates.
	* gcc/m2/gm2.texi:  corrected dates.
	* gcc/m2/gnu.texi:  corrected dates.
	* gcc/m2/lang-options.h:  corrected dates.
	* gcc/m2/lang-specs.h:  corrected dates.
	* gcc/m2/lang.opt:  corrected dates.
	* gcc/m2/m2-link-support.h:  corrected dates.
	* gcc/m2/m2-tree.def:  corrected dates.
	* gcc/m2/m2.flex:  corrected dates.
	* gcc/m2/mc-boot-ch/GRTco.c:  corrected dates.
	* gcc/m2/mc/mc.flex:  corrected dates.
	* gcc/m2/mc/mcComment.h:  corrected dates.
	* gcc/m2/mc/mcLexBuf.h:  corrected dates.
	* gcc/m2/mc/mcReserved.h:  corrected dates.
	* gcc/m2/tools-src/array2index.py:  corrected dates.
	* gcc/m2/tools-src/buildpg:  corrected dates.
	* gcc/m2/tools-src/buildsyntax:  corrected dates.
	* gcc/m2/tools-src/createUlmSys:  corrected dates.
	* gcc/m2/tools-src/def2texi.py:  corrected dates.
	* gcc/m2/tools-src/incfile:  corrected dates.
	* gcc/m2/tools-src/makeSystem:  corrected dates.
	* gcc/m2/tools-src/makeconfigure:  corrected dates.
	* gcc/m2/tools-src/makeversion:  corrected dates.
	* gcc/m2/tools-src/tidydates.py:  corrected dates.
	* gcc/m2/www/gm2-logo.ms:  corrected dates.
	* gcc/m2/www/tools/texi2tr/src/config.py:  corrected dates.
	* gcc/m2/www/tools/texi2tr/src/navigation.py:  corrected dates.
	* gcc/m2/www/tools/texi2tr/src/outputdev.py:  corrected dates.
	* gcc/m2/www/tools/texi2tr/src/texi2tr.py:  corrected dates.
	* gcc/m2/www/Makefile.in:  regenerted.
	* libgm2/Makefile.in:  regenerted.
	* libgm2/libm2cor/Makefile.in:  regenerted.
	* libgm2/libm2iso/Makefile.in:  regenerted.
	* libgm2/libm2log/Makefile.in:  regenerted.
	* libgm2/libm2min/Makefile.in:  regenerted.
	* libgm2/libm2pim/Makefile.in:  regenerted.

2021-01-14       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* bnf/gm2m.bnf:  removed unused local variables.
	* gm2-compiler/M2CaseList.mod:  removed unused local variables.
	* gm2-compiler/M2Check.mod:  removed unused local variables.
	* gm2-compiler/M2DebugStack.mod:  removed unused local variables.
	* gm2-compiler/M2Range.mod:  removed unused local variables.
	* gm2-compiler/M2Students.mod:  removed unused local variables.
	* gm2-compiler/Sets.mod:  removed unused local variables.
	* gm2-libs/IO.mod:  removed unused local variables.

2021-01-13       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* m2/gm2-compiler/M2CaseList.mod:  (DisposeRanges) remove
	unused variable tag.  (SubBitRange) remove dummy.  Use
	MetaErrorT0.
	* m2/gm2-compiler/M2GenGCC.mod:  Use tokenno rather than
	CurrentQuadToken when passed as a parameter.  (CodeMakeAdr)
	Initialize location before use.
	* m2/bnf/gm2l.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/gm2m.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/Make-lang.in:  updated dates and also the bootstrap path
	for mc.
	* m2/bnf/m2-1.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/m2-2.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/m2-3.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/m2-c.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/m2-h.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/m2.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/mc-1.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/mc-2.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/mc-3.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/mc-4.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/bnf/mc-5.bnf:  altered grammar to include <* noreturn *>
	attribute.
	* m2/gm2-compiler/M2BasicBlock.mod:  (ConvertQuads2BasicBlock) removed
	unused variable.
	* m2/gm2-compiler/M2Error.def:  (InternalError) added <* noreturn *>.
	* m2/gm2-compiler/M2Error.mod:  (InternalError) added <* noreturn *>.
	* m2/gm2-compiler/M2Quads.mod:  (CheckCompatibleWithBecomes) improved
	error messages and tidied up formatting.
	* m2/gm2-compiler/M2StackAddress.mod:  (PushAddress) removed unused variable.
	* m2/gm2-compiler/P0SymBuild.mod:  (pc) added comment.
	* m2/gm2-compiler/P1SymBuild.mod:  (CheckFileName) corrected type of basename.
	(P1StartBuildDefinitionModule) removed unused variable.  (BuildImportInnerModule)
	removed unused variable.  (BuildExportInnerModule) removed unused variable.
	* m2/gm2-compiler/SymbolTable.mod:  (IsLegal) removed useless comparison.
	* m2/gm2-compiler/gm2lgen.mod:  (GenExternals) removed unused variable.
	(GenInitializationCalls) removed unused variable.  (GenFinalizationCalls)
	removed unused variable.
	* m2/gm2-libs/M2RTS.def:  (Terminate) added <* noreturn *>.  (HALT)
	added <* noreturn *>.  (Halt) added <* noreturn *>.  (ErrorMessage)
	added <* noreturn *>.
	* m2/gm2-libs/M2RTS.mod:  (Terminate) added <* noreturn *>.  (HALT)
	added <* noreturn *>.  (Halt) added <* noreturn *>.  (ErrorMessage)
	added <* noreturn *>.
	* m2/gm2-libs/libc.def:  (abort) <* noreturn *>.  (exit) <* noreturn *>.
	* m2/mc-boot/GASCII.c:  (rebuilt).
	* m2/mc-boot/GASCII.h:  (rebuilt).
	* m2/mc-boot/GArgs.c:  (rebuilt).
	* m2/mc-boot/GArgs.h:  (rebuilt).
	* m2/mc-boot/GAssertion.c:  (rebuilt).
	* m2/mc-boot/GAssertion.h:  (rebuilt).
	* m2/mc-boot/GBreak.c:  (rebuilt).
	* m2/mc-boot/GBreak.h:  (rebuilt).
	* m2/mc-boot/GCOROUTINES.h:  (rebuilt).
	* m2/mc-boot/GCmdArgs.c:  (rebuilt).
	* m2/mc-boot/GCmdArgs.h:  (rebuilt).
	* m2/mc-boot/GDebug.c:  (rebuilt).
	* m2/mc-boot/GDebug.h:  (rebuilt).
	* m2/mc-boot/GDynamicStrings.c:  (rebuilt).
	* m2/mc-boot/GDynamicStrings.h:  (rebuilt).
	* m2/mc-boot/GEnvironment.c:  (rebuilt).
	* m2/mc-boot/GEnvironment.h:  (rebuilt).
	* m2/mc-boot/GFIO.c:  (rebuilt).
	* m2/mc-boot/GFIO.h:  (rebuilt).
	* m2/mc-boot/GFormatStrings.c:  (rebuilt).
	* m2/mc-boot/GFormatStrings.h:  (rebuilt).
	* m2/mc-boot/GFpuIO.c:  (rebuilt).
	* m2/mc-boot/GFpuIO.h:  (rebuilt).
	* m2/mc-boot/GIO.c:  (rebuilt).
	* m2/mc-boot/GIO.h:  (rebuilt).
	* m2/mc-boot/GIndexing.c:  (rebuilt).
	* m2/mc-boot/GIndexing.h:  (rebuilt).
	* m2/mc-boot/GM2EXCEPTION.c:  (rebuilt).
	* m2/mc-boot/GM2EXCEPTION.h:  (rebuilt).
	* m2/mc-boot/GM2RTS.c:  (rebuilt).
	* m2/mc-boot/GM2RTS.h:  (rebuilt).
	* m2/mc-boot/GMemUtils.c:  (rebuilt).
	* m2/mc-boot/GMemUtils.h:  (rebuilt).
	* m2/mc-boot/GNumberIO.c:  (rebuilt).
	* m2/mc-boot/GNumberIO.h:  (rebuilt).
	* m2/mc-boot/GPushBackInput.c:  (rebuilt).
	* m2/mc-boot/GPushBackInput.h:  (rebuilt).
	* m2/mc-boot/GRTExceptions.c:  (rebuilt).
	* m2/mc-boot/GRTExceptions.h:  (rebuilt).
	* m2/mc-boot/GRTco.h:  (rebuilt).
	* m2/mc-boot/GRTint.c:  (rebuilt).
	* m2/mc-boot/GRTint.h:  (rebuilt).
	* m2/mc-boot/GSArgs.c:  (rebuilt).
	* m2/mc-boot/GSArgs.h:  (rebuilt).
	* m2/mc-boot/GSFIO.c:  (rebuilt).
	* m2/mc-boot/GSFIO.h:  (rebuilt).
	* m2/mc-boot/GSYSTEM.h:  (rebuilt).
	* m2/mc-boot/GSelective.h:  (rebuilt).
	* m2/mc-boot/GStdIO.c:  (rebuilt).
	* m2/mc-boot/GStdIO.h:  (rebuilt).
	* m2/mc-boot/GStorage.c:  (rebuilt).
	* m2/mc-boot/GStorage.h:  (rebuilt).
	* m2/mc-boot/GStrCase.c:  (rebuilt).
	* m2/mc-boot/GStrCase.h:  (rebuilt).
	* m2/mc-boot/GStrIO.c:  (rebuilt).
	* m2/mc-boot/GStrIO.h:  (rebuilt).
	* m2/mc-boot/GStrLib.c:  (rebuilt).
	* m2/mc-boot/GStrLib.h:  (rebuilt).
	* m2/mc-boot/GStringConvert.c:  (rebuilt).
	* m2/mc-boot/GStringConvert.h:  (rebuilt).
	* m2/mc-boot/GSysExceptions.h:  (rebuilt).
	* m2/mc-boot/GSysStorage.c:  (rebuilt).
	* m2/mc-boot/GSysStorage.h:  (rebuilt).
	* m2/mc-boot/GTimeString.c:  (rebuilt).
	* m2/mc-boot/GTimeString.h:  (rebuilt).
	* m2/mc-boot/GUnixArgs.h:  (rebuilt).
	* m2/mc-boot/Galists.c:  (rebuilt).
	* m2/mc-boot/Galists.h:  (rebuilt).
	* m2/mc-boot/Gdecl.c:  (rebuilt).
	* m2/mc-boot/Gdecl.h:  (rebuilt).
	* m2/mc-boot/Gdtoa.h:  (rebuilt).
	* m2/mc-boot/Gerrno.h:  (rebuilt).
	* m2/mc-boot/Gkeyc.c:  (rebuilt).
	* m2/mc-boot/Gkeyc.h:  (rebuilt).
	* m2/mc-boot/Gldtoa.h:  (rebuilt).
	* m2/mc-boot/Glibc.h:  (rebuilt).
	* m2/mc-boot/Glibm.h:  (rebuilt).
	* m2/mc-boot/Glists.h:  (rebuilt).
	* m2/mc-boot/GmcComment.c:  (rebuilt).
	* m2/mc-boot/GmcComment.h:  (rebuilt).
	* m2/mc-boot/GmcComp.c:  (rebuilt).
	* m2/mc-boot/GmcComp.h:  (rebuilt).
	* m2/mc-boot/GmcDebug.c:  (rebuilt).
	* m2/mc-boot/GmcDebug.h:  (rebuilt).
	* m2/mc-boot/GmcError.c:  (rebuilt).
	* m2/mc-boot/GmcError.h:  (rebuilt).
	* m2/mc-boot/GmcFileName.h:  (rebuilt).
	* m2/mc-boot/GmcLexBuf.c:  (rebuilt).
	* m2/mc-boot/GmcLexBuf.h:  (rebuilt).
	* m2/mc-boot/GmcMetaError.c:  (rebuilt).
	* m2/mc-boot/GmcMetaError.h:  (rebuilt).
	* m2/mc-boot/GmcOptions.h:  (rebuilt).
	* m2/mc-boot/GmcPreprocess.h:  (rebuilt).
	* m2/mc-boot/GmcPretty.h:  (rebuilt).
	* m2/mc-boot/GmcPrintf.h:  (rebuilt).
	* m2/mc-boot/GmcQuiet.h:  (rebuilt).
	* m2/mc-boot/GmcReserved.h:  (rebuilt).
	* m2/mc-boot/GmcSearch.h:  (rebuilt).
	* m2/mc-boot/GmcStack.c:  (rebuilt).
	* m2/mc-boot/GmcStack.h:  (rebuilt).
	* m2/mc-boot/GmcStream.c:  (rebuilt).
	* m2/mc-boot/GmcStream.h:  (rebuilt).
	* m2/mc-boot/Gmcflex.h:  (rebuilt).
	* m2/mc-boot/Gmcp1.c:  (rebuilt).
	* m2/mc-boot/Gmcp1.h:  (rebuilt).
	* m2/mc-boot/Gmcp2.c:  (rebuilt).
	* m2/mc-boot/Gmcp2.h:  (rebuilt).
	* m2/mc-boot/Gmcp3.c:  (rebuilt).
	* m2/mc-boot/Gmcp3.h:  (rebuilt).
	* m2/mc-boot/Gmcp4.c:  (rebuilt).
	* m2/mc-boot/Gmcp4.h:  (rebuilt).
	* m2/mc-boot/Gmcp5.c:  (rebuilt).
	* m2/mc-boot/Gmcp5.h:  (rebuilt).
	* m2/mc-boot/GnameKey.c:  (rebuilt).
	* m2/mc-boot/GnameKey.h:  (rebuilt).
	* m2/mc-boot/GsymbolKey.c:  (rebuilt).
	* m2/mc-boot/GsymbolKey.h:  (rebuilt).
	* m2/mc-boot/Gtermios.h:  (rebuilt).
	* m2/mc-boot/Gtop.c:  (rebuilt).
	* m2/mc-boot/Gvarargs.c:  (rebuilt).
	* m2/mc-boot/Gvarargs.h:  (rebuilt).
	* m2/mc-boot/Gwlists.c:  (rebuilt).
	* m2/mc-boot/Gwlists.h:  (rebuilt).
	* m2/mc-boot/Gwrapc.h:  (rebuilt).
	* m2/mc/decl.def:  (setNoReturn) new procedure.
	* m2/mc/decl.mod:  (doProcedureHeadingC) added extra parameter for heading.
        (setNoReturn) new procedure.

2021-01-12       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* gm2-compiler/M2Quads.mod:  (BuildOddFunction) combinedok initialize
	before use during error case.  (BuildMinFunction) rewritten to
	initialize all tokens before use when an error condition occurs.
	(BuildConstFunctionCall) initialize paramtok and combinedtok before
	use.
	* m2pp.c:  (pl) renamed as ptcl and declared as external.
	* m2pp.h:  (ptcl) declared as external.

2021-01-11       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* configure.ac:  avoid comparing SYSTEM.o between stages during
	bootstrap checks.

2021-01-09       Gaius Mulley <gaius.mulley@southwales.ac.uk>

	* lang.opt:  commented out descriptions for options which are
	used by C.
	* updated all dates for the New Year.
	* tools-src/boilerplate.py:  detect GCC with runtime exceptions
	licence.
	* New year ChangeLog file.
